/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"time"
)

// checks if the Request type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Request{}

// Request struct for Request
type Request struct {
	DisplayName       NullableString     `json:"displayName,omitempty"`
	RequestorId       NullableString     `json:"requestorId,omitempty"`
	Status            *RequestStatus     `json:"status,omitempty"`
	Reason            NullableString     `json:"reason,omitempty"`
	ApprovedBy        NullableString     `json:"approvedBy,omitempty"`
	RequestType       *RequestType       `json:"requestType,omitempty"`
	TargetType        NullableString     `json:"targetType,omitempty"`
	TargetId1         NullableString     `json:"targetId1,omitempty"`
	TargetId2         NullableString     `json:"targetId2,omitempty"`
	EndTime           NullableTime       `json:"endTime,omitempty"`
	ExpirationTime    NullableTime       `json:"expirationTime,omitempty"`
	HasApprovalToken  *bool              `json:"hasApprovalToken,omitempty"`
	RequestParameters []RequestParameter `json:"requestParameters,omitempty"`
	Id                NullableString     `json:"id,omitempty"`
	CreationTime      *time.Time         `json:"creationTime,omitempty"`
}

// NewRequest instantiates a new Request object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRequest() *Request {
	this := Request{}
	return &this
}

// NewRequestWithDefaults instantiates a new Request object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRequestWithDefaults() *Request {
	this := Request{}
	return &this
}

// GetDisplayName returns the DisplayName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetDisplayName() string {
	if o == nil || IsNil(o.DisplayName.Get()) {
		var ret string
		return ret
	}
	return *o.DisplayName.Get()
}

// GetDisplayNameOk returns a tuple with the DisplayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DisplayName.Get(), o.DisplayName.IsSet()
}

// HasDisplayName returns a boolean if a field has been set.
func (o *Request) HasDisplayName() bool {
	if o != nil && o.DisplayName.IsSet() {
		return true
	}

	return false
}

// SetDisplayName gets a reference to the given NullableString and assigns it to the DisplayName field.
func (o *Request) SetDisplayName(v string) {
	o.DisplayName.Set(&v)
}

// SetDisplayNameNil sets the value for DisplayName to be an explicit nil
func (o *Request) SetDisplayNameNil() {
	o.DisplayName.Set(nil)
}

// UnsetDisplayName ensures that no value is present for DisplayName, not even an explicit nil
func (o *Request) UnsetDisplayName() {
	o.DisplayName.Unset()
}

// GetRequestorId returns the RequestorId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetRequestorId() string {
	if o == nil || IsNil(o.RequestorId.Get()) {
		var ret string
		return ret
	}
	return *o.RequestorId.Get()
}

// GetRequestorIdOk returns a tuple with the RequestorId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetRequestorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.RequestorId.Get(), o.RequestorId.IsSet()
}

// HasRequestorId returns a boolean if a field has been set.
func (o *Request) HasRequestorId() bool {
	if o != nil && o.RequestorId.IsSet() {
		return true
	}

	return false
}

// SetRequestorId gets a reference to the given NullableString and assigns it to the RequestorId field.
func (o *Request) SetRequestorId(v string) {
	o.RequestorId.Set(&v)
}

// SetRequestorIdNil sets the value for RequestorId to be an explicit nil
func (o *Request) SetRequestorIdNil() {
	o.RequestorId.Set(nil)
}

// UnsetRequestorId ensures that no value is present for RequestorId, not even an explicit nil
func (o *Request) UnsetRequestorId() {
	o.RequestorId.Unset()
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *Request) GetStatus() RequestStatus {
	if o == nil || IsNil(o.Status) {
		var ret RequestStatus
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Request) GetStatusOk() (*RequestStatus, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *Request) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given RequestStatus and assigns it to the Status field.
func (o *Request) SetStatus(v RequestStatus) {
	o.Status = &v
}

// GetReason returns the Reason field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetReason() string {
	if o == nil || IsNil(o.Reason.Get()) {
		var ret string
		return ret
	}
	return *o.Reason.Get()
}

// GetReasonOk returns a tuple with the Reason field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetReasonOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Reason.Get(), o.Reason.IsSet()
}

// HasReason returns a boolean if a field has been set.
func (o *Request) HasReason() bool {
	if o != nil && o.Reason.IsSet() {
		return true
	}

	return false
}

// SetReason gets a reference to the given NullableString and assigns it to the Reason field.
func (o *Request) SetReason(v string) {
	o.Reason.Set(&v)
}

// SetReasonNil sets the value for Reason to be an explicit nil
func (o *Request) SetReasonNil() {
	o.Reason.Set(nil)
}

// UnsetReason ensures that no value is present for Reason, not even an explicit nil
func (o *Request) UnsetReason() {
	o.Reason.Unset()
}

// GetApprovedBy returns the ApprovedBy field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetApprovedBy() string {
	if o == nil || IsNil(o.ApprovedBy.Get()) {
		var ret string
		return ret
	}
	return *o.ApprovedBy.Get()
}

// GetApprovedByOk returns a tuple with the ApprovedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetApprovedByOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ApprovedBy.Get(), o.ApprovedBy.IsSet()
}

// HasApprovedBy returns a boolean if a field has been set.
func (o *Request) HasApprovedBy() bool {
	if o != nil && o.ApprovedBy.IsSet() {
		return true
	}

	return false
}

// SetApprovedBy gets a reference to the given NullableString and assigns it to the ApprovedBy field.
func (o *Request) SetApprovedBy(v string) {
	o.ApprovedBy.Set(&v)
}

// SetApprovedByNil sets the value for ApprovedBy to be an explicit nil
func (o *Request) SetApprovedByNil() {
	o.ApprovedBy.Set(nil)
}

// UnsetApprovedBy ensures that no value is present for ApprovedBy, not even an explicit nil
func (o *Request) UnsetApprovedBy() {
	o.ApprovedBy.Unset()
}

// GetRequestType returns the RequestType field value if set, zero value otherwise.
func (o *Request) GetRequestType() RequestType {
	if o == nil || IsNil(o.RequestType) {
		var ret RequestType
		return ret
	}
	return *o.RequestType
}

// GetRequestTypeOk returns a tuple with the RequestType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Request) GetRequestTypeOk() (*RequestType, bool) {
	if o == nil || IsNil(o.RequestType) {
		return nil, false
	}
	return o.RequestType, true
}

// HasRequestType returns a boolean if a field has been set.
func (o *Request) HasRequestType() bool {
	if o != nil && !IsNil(o.RequestType) {
		return true
	}

	return false
}

// SetRequestType gets a reference to the given RequestType and assigns it to the RequestType field.
func (o *Request) SetRequestType(v RequestType) {
	o.RequestType = &v
}

// GetTargetType returns the TargetType field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetTargetType() string {
	if o == nil || IsNil(o.TargetType.Get()) {
		var ret string
		return ret
	}
	return *o.TargetType.Get()
}

// GetTargetTypeOk returns a tuple with the TargetType field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetTargetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetType.Get(), o.TargetType.IsSet()
}

// HasTargetType returns a boolean if a field has been set.
func (o *Request) HasTargetType() bool {
	if o != nil && o.TargetType.IsSet() {
		return true
	}

	return false
}

// SetTargetType gets a reference to the given NullableString and assigns it to the TargetType field.
func (o *Request) SetTargetType(v string) {
	o.TargetType.Set(&v)
}

// SetTargetTypeNil sets the value for TargetType to be an explicit nil
func (o *Request) SetTargetTypeNil() {
	o.TargetType.Set(nil)
}

// UnsetTargetType ensures that no value is present for TargetType, not even an explicit nil
func (o *Request) UnsetTargetType() {
	o.TargetType.Unset()
}

// GetTargetId1 returns the TargetId1 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetTargetId1() string {
	if o == nil || IsNil(o.TargetId1.Get()) {
		var ret string
		return ret
	}
	return *o.TargetId1.Get()
}

// GetTargetId1Ok returns a tuple with the TargetId1 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetTargetId1Ok() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetId1.Get(), o.TargetId1.IsSet()
}

// HasTargetId1 returns a boolean if a field has been set.
func (o *Request) HasTargetId1() bool {
	if o != nil && o.TargetId1.IsSet() {
		return true
	}

	return false
}

// SetTargetId1 gets a reference to the given NullableString and assigns it to the TargetId1 field.
func (o *Request) SetTargetId1(v string) {
	o.TargetId1.Set(&v)
}

// SetTargetId1Nil sets the value for TargetId1 to be an explicit nil
func (o *Request) SetTargetId1Nil() {
	o.TargetId1.Set(nil)
}

// UnsetTargetId1 ensures that no value is present for TargetId1, not even an explicit nil
func (o *Request) UnsetTargetId1() {
	o.TargetId1.Unset()
}

// GetTargetId2 returns the TargetId2 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetTargetId2() string {
	if o == nil || IsNil(o.TargetId2.Get()) {
		var ret string
		return ret
	}
	return *o.TargetId2.Get()
}

// GetTargetId2Ok returns a tuple with the TargetId2 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetTargetId2Ok() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetId2.Get(), o.TargetId2.IsSet()
}

// HasTargetId2 returns a boolean if a field has been set.
func (o *Request) HasTargetId2() bool {
	if o != nil && o.TargetId2.IsSet() {
		return true
	}

	return false
}

// SetTargetId2 gets a reference to the given NullableString and assigns it to the TargetId2 field.
func (o *Request) SetTargetId2(v string) {
	o.TargetId2.Set(&v)
}

// SetTargetId2Nil sets the value for TargetId2 to be an explicit nil
func (o *Request) SetTargetId2Nil() {
	o.TargetId2.Set(nil)
}

// UnsetTargetId2 ensures that no value is present for TargetId2, not even an explicit nil
func (o *Request) UnsetTargetId2() {
	o.TargetId2.Unset()
}

// GetEndTime returns the EndTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetEndTime() time.Time {
	if o == nil || IsNil(o.EndTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.EndTime.Get()
}

// GetEndTimeOk returns a tuple with the EndTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetEndTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.EndTime.Get(), o.EndTime.IsSet()
}

// HasEndTime returns a boolean if a field has been set.
func (o *Request) HasEndTime() bool {
	if o != nil && o.EndTime.IsSet() {
		return true
	}

	return false
}

// SetEndTime gets a reference to the given NullableTime and assigns it to the EndTime field.
func (o *Request) SetEndTime(v time.Time) {
	o.EndTime.Set(&v)
}

// SetEndTimeNil sets the value for EndTime to be an explicit nil
func (o *Request) SetEndTimeNil() {
	o.EndTime.Set(nil)
}

// UnsetEndTime ensures that no value is present for EndTime, not even an explicit nil
func (o *Request) UnsetEndTime() {
	o.EndTime.Unset()
}

// GetExpirationTime returns the ExpirationTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetExpirationTime() time.Time {
	if o == nil || IsNil(o.ExpirationTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ExpirationTime.Get()
}

// GetExpirationTimeOk returns a tuple with the ExpirationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetExpirationTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ExpirationTime.Get(), o.ExpirationTime.IsSet()
}

// HasExpirationTime returns a boolean if a field has been set.
func (o *Request) HasExpirationTime() bool {
	if o != nil && o.ExpirationTime.IsSet() {
		return true
	}

	return false
}

// SetExpirationTime gets a reference to the given NullableTime and assigns it to the ExpirationTime field.
func (o *Request) SetExpirationTime(v time.Time) {
	o.ExpirationTime.Set(&v)
}

// SetExpirationTimeNil sets the value for ExpirationTime to be an explicit nil
func (o *Request) SetExpirationTimeNil() {
	o.ExpirationTime.Set(nil)
}

// UnsetExpirationTime ensures that no value is present for ExpirationTime, not even an explicit nil
func (o *Request) UnsetExpirationTime() {
	o.ExpirationTime.Unset()
}

// GetHasApprovalToken returns the HasApprovalToken field value if set, zero value otherwise.
func (o *Request) GetHasApprovalToken() bool {
	if o == nil || IsNil(o.HasApprovalToken) {
		var ret bool
		return ret
	}
	return *o.HasApprovalToken
}

// GetHasApprovalTokenOk returns a tuple with the HasApprovalToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Request) GetHasApprovalTokenOk() (*bool, bool) {
	if o == nil || IsNil(o.HasApprovalToken) {
		return nil, false
	}
	return o.HasApprovalToken, true
}

// HasHasApprovalToken returns a boolean if a field has been set.
func (o *Request) HasHasApprovalToken() bool {
	if o != nil && !IsNil(o.HasApprovalToken) {
		return true
	}

	return false
}

// SetHasApprovalToken gets a reference to the given bool and assigns it to the HasApprovalToken field.
func (o *Request) SetHasApprovalToken(v bool) {
	o.HasApprovalToken = &v
}

// GetRequestParameters returns the RequestParameters field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetRequestParameters() []RequestParameter {
	if o == nil {
		var ret []RequestParameter
		return ret
	}
	return o.RequestParameters
}

// GetRequestParametersOk returns a tuple with the RequestParameters field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetRequestParametersOk() ([]RequestParameter, bool) {
	if o == nil || IsNil(o.RequestParameters) {
		return nil, false
	}
	return o.RequestParameters, true
}

// HasRequestParameters returns a boolean if a field has been set.
func (o *Request) HasRequestParameters() bool {
	if o != nil && !IsNil(o.RequestParameters) {
		return true
	}

	return false
}

// SetRequestParameters gets a reference to the given []RequestParameter and assigns it to the RequestParameters field.
func (o *Request) SetRequestParameters(v []RequestParameter) {
	o.RequestParameters = v
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Request) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Request) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *Request) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *Request) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *Request) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *Request) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *Request) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Request) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *Request) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *Request) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o Request) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Request) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.DisplayName.IsSet() {
		toSerialize["displayName"] = o.DisplayName.Get()
	}
	if o.RequestorId.IsSet() {
		toSerialize["requestorId"] = o.RequestorId.Get()
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if o.Reason.IsSet() {
		toSerialize["reason"] = o.Reason.Get()
	}
	if o.ApprovedBy.IsSet() {
		toSerialize["approvedBy"] = o.ApprovedBy.Get()
	}
	if !IsNil(o.RequestType) {
		toSerialize["requestType"] = o.RequestType
	}
	if o.TargetType.IsSet() {
		toSerialize["targetType"] = o.TargetType.Get()
	}
	if o.TargetId1.IsSet() {
		toSerialize["targetId1"] = o.TargetId1.Get()
	}
	if o.TargetId2.IsSet() {
		toSerialize["targetId2"] = o.TargetId2.Get()
	}
	if o.EndTime.IsSet() {
		toSerialize["endTime"] = o.EndTime.Get()
	}
	if o.ExpirationTime.IsSet() {
		toSerialize["expirationTime"] = o.ExpirationTime.Get()
	}
	if !IsNil(o.HasApprovalToken) {
		toSerialize["hasApprovalToken"] = o.HasApprovalToken
	}
	if o.RequestParameters != nil {
		toSerialize["requestParameters"] = o.RequestParameters
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

type NullableRequest struct {
	value *Request
	isSet bool
}

func (v NullableRequest) Get() *Request {
	return v.value
}

func (v *NullableRequest) Set(val *Request) {
	v.value = val
	v.isSet = true
}

func (v NullableRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRequest(val *Request) *NullableRequest {
	return &NullableRequest{value: val, isSet: true}
}

func (v NullableRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
